; ##############################################################################
; ##############################################################################
; ##############################################################################
TSIC_A_ABFRAGEN:
	; INITIALISIERUNG		
	STS(adr_TSIC_A_TEMPERATUR_L),NULL
	STS(adr_TSIC_A_TEMPERATUR_H),NULL
	clr temp6					; PARITT						
	clr temp8 					; STROBE						
	clr temp9					; Impulslnge					
;===============================================================================
	; sendet Sensor DATEN ?											
	; (nach Pegelwechsel suchen)									
	rcall TSIC_A_DATEN_SUCHEN	; OUT temp
	tst temp
	brne TSIC_A_ABFRAGEN_DATEN_OK
	; ERROR (keine DATEN)	
	cbi PORTB,LED_B_ROT			; ROT	
	; ERROR TEMPERATUR Wert	
	ldi temp1,LOW (-999)	
	ldi temp2,HIGH(-999)	
	STS(adr_TSIC_A_TEMPERATUR_L),temp1
	STS(adr_TSIC_A_TEMPERATUR_H),temp2
	ret
TSIC_A_ABFRAGEN_DATEN_OK:
;===============================================================================
	; kurze Pause (ca. 3...90ms Abstand Datenpakete) 		
	; Hinweis: An dieser Stelle kann das "flackern" der LEDs
	; beim Messvorgang minimiert werden						
	rcall wait_20ms
	;rcall wait_20ms
	;rcall wait_20ms
	;rcall wait_20ms
	;rcall wait_5ms
	;rcall wait_5ms
	;rcall wait_5ms
	;rcall wait_1ms
;===============================================================================
	; GELB 					
	cbi PORTB,LED_B_GELB
	; Interrupts sperren	
	CLI	
	; Display aus			
	rcall DIGIT_ALLES_AUS
;===============================================================================
	; START-BIT (STROBE)	
	rcall TSIC_A_PIN_ABFRAGEN	; out temp/temp9	
	; Strobe 9->1MHz 72->8MHz	
	STS(adr_TSIC_A_STROBE),temp9; STROBE speichern im SRAM		
	mov temp8,temp9				; STROBE speichern im Register	
	; Fehlerprfung (STROBE)				
	; STROBE darf 254 nicht berschreiten !	
	cpi temp9,254
	brlo TSIC_A_ABFRAGEN_STROBE_OK
	; ERROR (STROBE)
	cbi PORTB,LED_B_ROT			; ROT	
	; ERROR TEMPERATUR Wert	
	ldi temp1,LOW (-980)	
	ldi temp2,HIGH(-980)	
	STS(adr_TSIC_A_TEMPERATUR_L),temp1
	STS(adr_TSIC_A_TEMPERATUR_H),temp2	
	; Interrupts freigeben	
	sei
	ret
TSIC_A_ABFRAGEN_STROBE_OK:
;===============================================================================
	clr temp1
	clr temp2
	; Bit-7 (MSB)	
	rcall TSIC_A_PIN_ABFRAGEN	; out temp	
	LSL temp
	ROL temp2
	; Bit-6			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp2
	; Bit-5			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp2
	; Bit-4			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp2
;-------------------------------------------------------------------------------
	; ERROR-CHECK (Bit 7 bis 4 muss NULL sein
	mov temp,temp2
	andi temp,0b11111000
	tst temp
	breq TSIC_A_ABFRAGEN_NULL_OK
	; ERROR (NULL-CHECK)			
	cbi PORTB,LED_B_ROT			; ROT	
	; ERROR TEMPERATUR Wert	
	ldi temp1,LOW (-960)	
	ldi temp2,HIGH(-960)	
	STS(adr_TSIC_A_TEMPERATUR_L),temp1
	STS(adr_TSIC_A_TEMPERATUR_H),temp2	
	; Interrupts freigeben	
	sei
	ret
TSIC_A_ABFRAGEN_NULL_OK:
;-------------------------------------------------------------------------------
	; Bit-3			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp2
	; Bit-2			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp2
	; Bit-1			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp2
	; Bit-0	(LSB)	
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp2
	; PARITY-BIT	
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
;-------------------------------------------------------------------------------
	; PARITTS-PRFUNG		
	mov temp6,temp2
	rcall TSIC_PARITAET_BERECHNEN	; inp/out: temp6
	cp temp6,temp
	breq TSIC_A_ABFRAGEN_P1_OK
	; ERROR (MSB)	
	cbi PORTB,LED_B_ROT		; ROT		
	; ERROR TEMPERATUR Wert	
	ldi temp1,LOW (-940)	
	ldi temp2,HIGH(-940)	
	STS(adr_TSIC_A_TEMPERATUR_L),temp1
	STS(adr_TSIC_A_TEMPERATUR_H),temp2	
	; Interrupts freigeben	
	sei
	ret
TSIC_A_ABFRAGEN_P1_OK:
;===============================================================================
; An dieser Stelle htte man ca. 200s Pause fr ev. Interruptabarbeitung		
	; Interrupts freigeben	
	sei
	; Interrupts sperren	
	cli
	; Display aus			
	rcall DIGIT_ALLES_AUS
;===============================================================================
	; START-BIT		
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	; Bit-7 (MSB)	
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp1
	; Bit-6			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp1
	; Bit-5			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp1
	; Bit-4			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp1
	; Bit-3			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp1
	; Bit-2			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp1
	; Bit-1			
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp1
	; Bit-0	(LSB)	
	rcall TSIC_A_PIN_ABFRAGEN	; out temp
	LSL temp
	ROL temp1
	; PARITY-BIT	
	rcall TSIC_A_PIN_ABFRAGEN	; out temp

;-------------------------------------------------------------------------------
	; PARITTS-PRFUNG		
	mov temp6,temp1
	rcall TSIC_PARITAET_BERECHNEN	; inp/out: temp6
	cp temp6,temp
	breq TSIC_A_ABFRAGEN_P2_OK
	; ERROR (LSB)
	cbi PORTB,LED_B_ROT		; ROT		
	; ERROR TEMPERATUR Wert	
	ldi temp1,LOW (-920)	
	ldi temp2,HIGH(-920)	
	STS(adr_TSIC_A_TEMPERATUR_L),temp1
	STS(adr_TSIC_A_TEMPERATUR_H),temp2	
	; Interrupts freigeben	
	sei
	ret
TSIC_A_ABFRAGEN_P2_OK:
;-------------------------------------------------------------------------------
	; Interrupts freigeben	
	sei	
	; GELB 					
	sbi PORTB,LED_B_GELB
;-------------------------------------------------------------------------------
	; BERECHNUNG Temperatur	
	rcall TSIC_TEMPERATUR_BERECHNUNG	; inp/out temp1+2	
	; Temperatur speichern	
	STS(adr_TSIC_A_TEMPERATUR_L),temp1
	STS(adr_TSIC_A_TEMPERATUR_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; OUT: temp																		
; nach einem Pegelwechsel suchen												
TSIC_A_DATEN_SUCHEN:
	; Schleifen-Initialisierung							
	; Hinweis: ist Schleife zu hoch eingestellt, dann	
	; dauert es zu lang, bis fehlende Pegelwechsel		
	; erkannt werden									
	clr temp1
	clr temp2
	ldi temp3,10
	; SCHLEIFE					
TSIC_A_DATEN_SUCHEN_L:
	WDR
	dec temp1
	brne TSIC_A_DATEN_SUCHEN_L_W
	dec temp2
	brne TSIC_A_DATEN_SUCHEN_L_W
	dec temp3
	brne TSIC_A_DATEN_SUCHEN_L_W
	; ERROR			
	clr temp
	ret
TSIC_A_DATEN_SUCHEN_L_W:
	sbic (TSIC_A_PORT),(TSIC_A_PIN)        ; "skip if bit ..."
	rjmp TSIC_A_DATEN_SUCHEN_L	
;-------------------------------------------------------------------------------
	; Schleifen-Initialisierung	
	; Hinweis: ist Schleife zu hoch eingestellt, dann	
	; dauert es zu lang, bis fehlende Pegelwechsel		
	; erkannt werden									
	clr temp1
	clr temp2
	ldi temp3,10
	; SCHLEIFE					
TSIC_A_DATEN_SUCHEN_H:
	WDR
	dec temp1
	brne TSIC_A_DATEN_SUCHEN_H_W
	dec temp2
	brne TSIC_A_DATEN_SUCHEN_H_W
	dec temp3
	brne TSIC_A_DATEN_SUCHEN_H_W
	; ERROR			
	clr temp
	ret
TSIC_A_DATEN_SUCHEN_H_W:
	sbis (TSIC_A_PORT),(TSIC_A_PIN)        ; "skip if bit ..."
	rjmp TSIC_A_DATEN_SUCHEN_H	
;-------------------------------------------------------------------------------
	; Freigabe		
	ldi temp,1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp8 (STROBE) 															
; OUT: temp + temp9(Impulslnge)												
TSIC_A_PIN_ABFRAGEN:
	clr temp9
SENSOR_PIN_ABFRAGEN_HIGH_PEGEL:
	; Warteschleife, wenn PIN "HIGH" ist			
	sbic (TSIC_A_PORT),(TSIC_A_PIN)        ; "skip if bit ..."
	rjmp SENSOR_PIN_ABFRAGEN_HIGH_PEGEL


SENSOR_PIN_ABFRAGEN_LOW_PEGEL:
	; Warteschleife, wenn PIN "LOW" ist			
	;nop							; "nop" ev. bei 16MHz erforderlich	
	inc temp9 					; ZHLER+1
	tst temp9 					; BERLAUF ?
	brne SENSOR_PIN_ABFRAGEN_LOW_PEGEL_OK
	cpi temp9,255
SENSOR_PIN_ABFRAGEN_LOW_PEGEL_OK:
	sbis (TSIC_A_PORT),(TSIC_A_PIN)        ; "skip if bit ..."	
	rjmp SENSOR_PIN_ABFRAGEN_LOW_PEGEL

	; VERGLEICH	mit STROBE-WERT					
	cp temp9,temp8
	brlo SENSOR_LOGIC_HIGH
SENSOR_LOGIC_LOW:
	clr temp
	ret
SENSOR_LOGIC_HIGH:
	ldi temp,255
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp1 + temp2															
; OUT: temp1 + temp2															
;===============================================================================
; BERECHNUNG der Temperatur aus den Temperaturdaten								
; Formel:	C = WERT x 2000/2048-500											
;	-50C	   0 (0x000)														
;	-10C	 409 (0x199)														
;	  0C	 512 (0x200)														
;	 25C	 767 (0x2FF)														
;	 60C	1125 (0x465)														
;	125C	1790 (0x6FE)														
;	150C	2047 (0x7FF)														
TSIC_TEMPERATUR_BERECHNUNG:
	clr temp3
	mov temp4,temp1
	mov temp5,temp2
	clr temp6
	; x 2000					
	ldi ZL,LOW (2000-1)
	ldi ZH,HIGH(2000-1)
TSIC_TEMPERATUR_BERECHNUNG_SCHLEIFE:
	add temp1,temp4
	adc temp2,temp5
	adc temp3,temp6
	sbiw ZL,1
	tst ZL
	brne TSIC_TEMPERATUR_BERECHNUNG_SCHLEIFE
	tst ZH
	brne TSIC_TEMPERATUR_BERECHNUNG_SCHLEIFE
	; :2048						
	mov temp1,temp2	; :256
	mov temp2,temp3
	LSR temp2		; :2	
	ROR temp1
	LSR temp2		; :2	
	ROR temp1
	LSR temp2		; :2	
	ROR temp1
	; -500						
	ldi temp3,low (-500)
	ldi temp4,high(-500)
	add temp1,temp3
	adc temp2,temp4
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; INP: temp6																	
; OUT: temp6																	
TSIC_PARITAET_BERECHNEN:
	push temp	; sichern			
	clr temp	

	; 1xrechts ==> Carry rollt raus
	LSR temp6
	rcall TSIC_PARITAET_BERECHNEN_Z
	LSR temp6
	rcall TSIC_PARITAET_BERECHNEN_Z
	LSR temp6
	rcall TSIC_PARITAET_BERECHNEN_Z
	LSR temp6
	rcall TSIC_PARITAET_BERECHNEN_Z
	LSR temp6
	rcall TSIC_PARITAET_BERECHNEN_Z
	LSR temp6
	rcall TSIC_PARITAET_BERECHNEN_Z
	LSR temp6
	rcall TSIC_PARITAET_BERECHNEN_Z
	LSR temp6
	rcall TSIC_PARITAET_BERECHNEN_Z
	; Bitmuster 	
	andi temp,0b00000001
	; gleich NULL ?	
	tst temp
	brne TSIC_PARITAET_BERECHNEN_1
TSIC_PARITAET_BERECHNEN_0:
	; Ergebnis 		
	ldi temp6,0
	pop temp ; wieder herstellen	
	ret
TSIC_PARITAET_BERECHNEN_1:
	; Ergebnis 		
	ldi temp6,255
	pop temp ; wieder herstellen	
	ret
;-------------------------------------------------------------------------------
TSIC_PARITAET_BERECHNEN_Z:
	brcs TSIC_PARITAET_BERECHNEN_ZZ
	ret
TSIC_PARITAET_BERECHNEN_ZZ:
	; Carrys zhlen	
	inc temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

